AutoTurnin = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0")

local QUEST_PROGRESS = nil
local QUEST_COMPLETE = nil

-- quest autocomplete handlers and functions
function AutoTurnin:OnEnable()
	self:RegisterEvent("GOSSIP_SHOW")
	self:RegisterEvent("QUEST_PROGRESS")
	self:RegisterEvent("QUEST_COMPLETE")
end

function AutoTurnin:GOSSIP_SHOW()
	QUEST_PROGRESS = nil
	QUEST_COMPLETE = nil
	local availableQuests = {}
	for _, availableQuestName in pairs({GetGossipAvailableQuests()}) do
		if type(availableQuestName) == "string" then
			table.insert(availableQuests, availableQuestName)
		end
	end
	if getn(availableQuests) > 0 then
		for i, availableQuestName in ipairs(availableQuests) do
			local questItems = self.Quests[availableQuestName]
			if questItems then
				if self:CanCompleteQuest(questItems) then
					QUEST_PROGRESS = availableQuestName
					SelectGossipAvailableQuest(i)
					return
				end
			end
		end
		for i, availableQuestName in ipairs(availableQuests) do
			local questItems = self.QuestsSingle[availableQuestName]
			if questItems then
				if self:CanCompleteQuest(questItems) then
					QUEST_PROGRESS = availableQuestName
					SelectGossipAvailableQuest(i)
					return
				end
			end
		end
	end
end

function AutoTurnin:QUEST_PROGRESS()
	if GetTitleText() == QUEST_PROGRESS then
		QUEST_COMPLETE = GetTitleText()
		CompleteQuest()
	end
	QUEST_PROGRESS = nil
end

function AutoTurnin:QUEST_COMPLETE()
	if GetTitleText() == QUEST_COMPLETE then
		if GetNumQuestChoices() == 0 then
			GetQuestReward()
		end
	end
	QUEST_COMPLETE = nil
end

function AutoTurnin:CanCompleteQuest(t)
	for k,v in pairs(t) do
		if GetItemCount(k) < v then
			return false
		end 
	end
	return true
end